﻿using System;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace DotNetControls
{
    [Guid("BBFD1E56-97D8-460C-8534-FF5DF264BCF6")]
    [InterfaceType(ComInterfaceType.InterfaceIsIDispatch)]
    public interface ContextMenuEvents
    {
        [DispId(1)]
        void ItemClick(string ItemName);
    }

    [Guid("ED20E6D7-E718-4525-9D83-2074EAB52292")]
    [ClassInterface(ClassInterfaceType.None)]
    [ComSourceInterfaces(typeof(ContextMenuEvents))]
    public partial class ContextMenu : COMUserControl, ContextMenuInterface
    {
        public ContextMenu()
        {
            InitializeComponent();
        }

        public delegate void ItemClickEventHandler(string itemName);
        event ItemClickEventHandler ItemClick;
        private void MenuItem_Click(object sender, EventArgs e)
        {
            if (ItemClick != null)
            {
                ToolStripMenuItem item = (ToolStripMenuItem)sender;
                ItemClick(item.Name);
            }
        }

        public ToolStripMenuItem AddBar(string name, string text, string shortcutKey, string imageFile)
        {
            ToolStripMenuItem newBar = new ToolStripMenuItem();
            this.Control.Items.Add(newBar);
            newBar.Name = name;
            newBar.Text = text;
            newBar.Size = new System.Drawing.Size(140, 22);
            newBar.Click += new System.EventHandler(this.MenuItem_Click);
            if (imageFile != "")
            {
                newBar.Image = System.Drawing.Image.FromFile(imageFile);
                newBar.ImageTransparentColor = System.Drawing.Color.White;
            }
            if (shortcutKey != "")
            {
                char key = shortcutKey.ToUpper().ToCharArray()[0];
                newBar.ShortcutKeys = ((Keys)((Keys.Control | (Keys)(byte)key)));
            }
            return newBar;
        }

        public void ShowMenu()
        {
            this.Control.Show(Cursor.Position.X, Cursor.Position.Y);
        }

        public void Clear()
        {
            this.Control.Items.Clear();
        }
    }

    public interface ContextMenuInterface
    {
        ToolStripMenuItem AddBar(string name, string text, string shortcutKey, string imageFile);
        void ShowMenu();
    }
}
