﻿using System;
using System.Windows.Forms;
using System.Drawing;
using System.Runtime.InteropServices;

namespace DotNetControls
{
    [Guid("6D02D122-0F41-4205-BD00-388ECE9AF3E3")]
    [ClassInterface(ClassInterfaceType.None)]
    public partial class DateTimePicker : COMUserControl, DateTimePickerInterface
    {
        public DateTimePicker()
        {
            InitializeComponent();
        }

        public DateTime Value
        {
            get { return this.Control.Value; }
            set { this.Control.Value = value; }
        }

        public int Format
        {
            get { return (int)this.Control.Format; }
            set { this.Control.Format = (DateTimePickerFormat)value; }
        }

        public string CustomFormat
        {
            get { return this.Control.CustomFormat; }
            set { this.Control.CustomFormat = value; }
        }

        public string FontName
        {
            get { return this.Control.Font.Name; }
            set { this.Control.Font = new Font(value, this.Control.Font.Size); }
        }

        public float FontSize
        {
            get { return this.Control.Font.Size; }
            set { this.Control.Font = new Font(this.Control.Font.Name, value); }
        }
    }

    public interface DateTimePickerInterface
    {
        DateTime Value { get; set; }
        int Format { get; set; }
        string CustomFormat { get; set; }
        string FontName { get; set; }
        float FontSize { get; set; }
    }
}
