﻿using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace DotNetControls
{
    [Guid("A4E548B7-D31E-43C0-8B25-A77CDE2C383C")]
    [ClassInterface(ClassInterfaceType.None)]
    public class Dialogs : COMUserControl, DialogsInterface
    {
        public string DefaultExt { get; set; }
        public string FileName { get; set; }
        public string InitialDir { get; set; }
        public string Title { get; set; }
        public string Filter { get; set; }
        public int FilterIndex { get; set; }

        public string ShowOpenDialog()
        {
            string fileName;
            OpenFileDialog dialog = new OpenFileDialog();
            dialog.FileName = FileName;
            dialog.DefaultExt = DefaultExt;
            dialog.InitialDirectory = InitialDir;
            dialog.Title = Title;
            dialog.Filter = Filter;
            dialog.FilterIndex = FilterIndex;

            if (dialog.ShowDialog() == DialogResult.OK)
                fileName = dialog.FileName;
            else
                fileName = "";
            return fileName;
        }

        public string ShowSaveDialog()
        {
            string fileName;
            SaveFileDialog dialog = new SaveFileDialog();
            dialog.FileName = FileName;
            dialog.DefaultExt = DefaultExt;
            dialog.InitialDirectory = InitialDir;
            dialog.Title = Title;
            dialog.Filter = Filter;
            dialog.FilterIndex = FilterIndex;

            if (dialog.ShowDialog() == DialogResult.OK)
                fileName = dialog.FileName;
            else
                fileName = "";
            return fileName;
        }
    }

    public interface DialogsInterface
    {
        string DefaultExt { get; set; }
        string FileName { get; set; }
        string InitialDir { get; set; }
        string Title { get; set; }
        string Filter { get; set; }
        int FilterIndex { get; set; }

        string ShowOpenDialog();
        string ShowSaveDialog();
    }
}
