﻿using System;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace DotNetControls
{
    [Guid("39DE6E4D-AA39-4F64-99A5-26BB644F3673")]
    [InterfaceType(ComInterfaceType.InterfaceIsIDispatch)]
    public interface ToolbarEvents
    {
        [DispId(1)]
        void ButtonClick(string ButtonName);
    }

    [Guid("490BC36D-0A17-49F4-A491-28DDAF361EDF")]
    [ClassInterface(ClassInterfaceType.None)]
    [ComSourceInterfaces(typeof(ToolbarEvents))]
    public partial class Toolbar : COMUserControl, ToolbarInterface
    {
        public Toolbar()
        {
            InitializeComponent();
        }

        public delegate void ButtonClickEventHandler(string ButtonName);
        event ButtonClickEventHandler ButtonClick;
        private void ToolStripButton_Click(object sender, EventArgs e)
        {
            if (ButtonClick != null)
            {
                ToolStripButton button = (ToolStripButton)sender;
                ButtonClick(button.Name);
            }
        }

        public ToolStripButton AddButton(string name, string text,
        string imageFile)
        {
            ToolStripButton newButton = new ToolStripButton();
            this.toolStrip.Items.Add(newButton);
            newButton.DisplayStyle = ToolStripItemDisplayStyle.Image;
            newButton.Image = System.Drawing.Image.FromFile(imageFile);
            newButton.ImageTransparentColor = System.Drawing.Color.White;
            newButton.Name = name;
            newButton.AutoSize = true;
            newButton.Text = text;
            newButton.Click += new System.EventHandler(this.ToolStripButton_Click);
            return newButton;
        }
    }

    public interface ToolbarInterface
    {
        ToolStripButton AddButton(string name, string text, string imageFile);
    }
}
